#include <bits/stdc++.h>

using namespace std;

int sela[80000];
vector<int> putevi[80000];

map<int, map<int, int>> udaljenost;

int izracunajD(int x, int y, int parent)
{
    if(x == y)
        return 0;
    else
    {
        int d = -1;
        for(int i = 0; i < (int)putevi[x].size(); i++)
        {
            if(putevi[x][i] != parent)
                d = izracunajD(putevi[x][i], y, x);
            if(d != -1)
            {
                d += 1;
                break;
            }
        }
        return d;
    }
}

int funkcija(int l, int r, int x)
{
    int rez = 0;
    int d;
    for(int i = l; i <= r; i++)
    {
        d = udaljenost[min(x, i)][max(x, i)];
        if(d == 0)
        {
            map<int, int> mapa;
            d = izracunajD(x, sela[i], -1);
            mapa.insert(make_pair(max(x, sela[i]), d));
            udaljenost.insert( make_pair( min(x, sela[i]), mapa) );
        }
        if(rez < d)
            rez = d;
    }
    return rez;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cerr.tie(NULL);
    cout.tie(NULL);

    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> sela[i];
        sela[i]--;
    }

    int p, k;
    for(int i = 0; i < n-1; i++)
    {
        cin >> p >> k;
        p--;
        k--;
        putevi[p].push_back(k);
        putevi[k].push_back(p);
    }

    int q;
    cin >> q;
    int tip, a, b, temp, l, r, x;
    int hakeri = 0;
    int ispis[q];
    for(int i = 0; i < q; i++)
    {
        cin >> tip;
        if(tip == 1)
        {
            cin >> a >> b;
            a--;
            b--;
            temp = sela[a];
            sela[a] = sela[b];
            sela[b] = temp;
        }
        else
        {
            cin >> l >> r >> x;
            l--; r--; x--;
            ispis[hakeri] = funkcija(l, r, x);
            hakeri++;
        }
    }

    for(int i = 0; i < hakeri; i++)
        cout << ispis[i] << endl;
    return 0;
}